#ifndef TILDA_CONTROLLER_H
#define TILDA_CONTROLLER_H

#include <glib-object.h>

#define TILDA_TYPE_CONTROLLER				(tilda_controller_get_type ())
#define TILDA_CONTROLLER(obj)				(G_TYPE_CHECK_INSTANCE_CAST ((obj), TILDA_TYPE_CONTROLLER, TildaController))
#define TILDA_CONTROLLER_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), TILDA_TYPE_CONTROLLER, TildaControllerClass))
#define TILDA_IS_CONTROLLER(obj)			(G_TYPE_CHECK_INSTANCE_TYPE ((obj), TILDA_TYPE_CONTROLLER))
#define TILDA_IS_CONTROLLER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), TILDA_TYPE_CONTROLLER))
#define TILDA_CONTROLLER_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), TILDA_TYPE_CONTROLLER, TildaControllerClass))

typedef struct _TildaController TildaController;
typedef struct _TildaControllerClass TildaControllerClass;

struct _TildaController {
	GObject parent;
	gboolean dispose_has_run;

	/* instance members */
	GPtrArray *windows;

	gint initial_windows;
};

struct _TildaControllerClass {
	GObjectClass parent;
};

/* Used by TILDA_TYPE_CONTROLLER */
GType tilda_controller_get_type (void);

/* DBus API */
gboolean tilda_controller_add_window (TildaController *self); // FIXME: needs GError
gboolean tilda_controller_quit (TildaController *self, GError **error);

/* API */
gboolean tilda_controller_remove_window (TildaController *self, gint window_number);
gboolean tilda_controller_global_key_in_use (const TildaController *self, const gchar *keystr);

#endif /* TILDA_CONTROLLER_H */

/* vim: set ts=4 sts=4 sw=4 noet tw=112: */
